﻿var tamilMode = new Boolean();
var isPrevConsonant = new Boolean();
var isCtrl = new Boolean();
var myChar, prevChar, newText;
var isPrevVowel = new Boolean();
var isKeetruCondition = new Boolean(); // this flag is set on entry of consonant and reset after
//a nedil is entered, or after two kuRils are entered. 

function anjalkeyboard() {

tamilMode = true;
isPrevVowel = false;
isPrevConsonant = false;
isKeetruCondition = false;
isCtrl = false;
window.onkeypress = handleKeyPressAnjal;
window.onkeydown = handleKeyDownAnjal;
window.onkeyup = handleKeyUpAnjal;
return;
}

function handleKeyPressAnjal(evt) {

if (evt.charCode && tamilMode && !isCtrl) {
//Case 1: key pressed is character, mode is tamil and not a control sequence

if (evt.charCode > 255)
return; // dont capture tamil events

myChar = String.fromCharCode(evt.charCode);

if(!isVowelAnjal(myChar) && !isConsonantAnjal(myChar)){
isPrevConsonant = false;
isPrevVowel = false;
isKeetruCondition = false;
return; //dont handle non-Anjal characters
}

if (isVowelAnjal(myChar)) { 
//Case 1.1: char is a vowel
if (isPrevVowel) {
//Case 1.1.1 prev char is vowel
if (isKeetruCondition) {
//case 1.1.1.1 keetru condition is true
if (prevChar==myChar) {
evt.preventDefault();
inputAnjal(evt, "nedil-keetru"); //change kuRil keetru to nedil keetru 
}
else if (isComplexChar(prevChar.concat(myChar))) {
evt.preventDefault();
inputAnjal(evt, "complex-keetru"); //'ai' or 'au' keetrus
}
else {
evt.preventDefault();
inputAnjal(evt, "letter") // enter the letter
}
isKeetruCondition = false;
}//case 1.1.1.1 ends
else { 
//case 1.1.1.2: not keetru condition
if (prevChar==myChar) {
evt.preventDefault();
inputAnjal(evt, "nedil-letter"); //change kuril letter to nedil letter
}
else if (isComplexChar(prevChar.concat(myChar))) {
evt.preventDefault();
inputAnjal(evt, "complex-letter"); // 'ai' or 'au' letters
}
else {
evt.preventDefault();
inputAnjal(evt, "letter"); //enter the letter
}
}//case 1.1.1.2 ends
isPrevConsonant = false;
isPrevVowel = false;
isKeetruCondition = false;
}//case 1.1.1 ends
else if (isPrevConsonant) {
//Case 1.1.2 prev char is Consonant 
evt.preventDefault();
inputAnjal(evt, "keetru"); // enter keetru 
if (isNedil(myChar)) {
isKeetruCondition = false;
isPrevVowel = false;
}
else 
isPrevVowel = true;
isPrevConsonant = false;
}//case 1.1.2 ends
else {
//Case 1.1.3 prev char is not alphabet
evt.preventDefault();
inputAnjal(evt, "letter"); //enter the letter
isPrevVowel = true;
isPrevConsonant = false;
}//case 1.1.3 ends
prevChar = myChar;
}//Case1.1 ends
else { 
//Case 1.2: char is a consonant
if (isPrevConsonant) { 
//Case 1.2.1 prev char is consonant
if (isComplexChar(prevChar.concat(myChar))) {
evt.preventDefault();
inputAnjal(evt, "complex-letter"); //enter complex letter
}
else {//not complex char 
evt.preventDefault();
inputAnjal(evt, "letter"); //enter the letter
}
}//case 1.2.1 ends
else {
//case 1.2.2: prev char is not consonant
evt.preventDefault();
inputAnjal(evt, "letter"); //enter the letter
}
prevChar = myChar;
isKeetruCondition = true;
isPrevConsonant = true;
isPrevVowel = false;
}//case 1.2 ends

}// case 1 ends

else {
//Case 2: key pressed is non-charecter 
if(evt.keyCode==120){//'F9' pressed
tamilMode = !tamilMode;
isPrevConsonant = false;
isPrevVowel = false;
isKeetruCondition = false;
}
}//case 2 ends
}//end of keypress handler function


function inputAnjal(e, optionString) {

if (e.target.type=="text") {
//case: text type

var myString =  e.target.value;
var len = myString.length; 

if (optionString=="keetru") {
len--;
e.target.value = myString.substr(0,len) + getKeetruAnjal(myChar);
}
else if (optionString=="nedil-keetru") {
if (myChar!='a')
len--;
e.target.value = myString.substr(0,len) + getKeetruAnjal(myChar.toUpperCase());
}
else if (optionString=="complex-keetru") {
e.target.value = e.target.value + getKeetruAnjal(prevChar.concat(myChar));
}
else if (optionString=="nedil-letter") {
len--;
e.target.value = myString.substr(0,len) + getAnjalChar(myChar.toUpperCase());
}
else if (optionString=="complex-letter") {
len--;
if (isPrevConsonant)
len--;
e.target.value = myString.substr(0,len) + getAnjalChar(prevChar.concat(myChar));
}
else 
e.target.value = myString + getAnjalChar(myChar);
}//case: 'text' type ends
else { //case: non-text type 
var myCode;
if (optionString=="keetru") {
var ev = document.createEvent("KeyEvents");
ev.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 8, 0);
e.target.dispatchEvent(ev); //insert backspace to remove 'otru'
myCode = getKeetruAnjal(myChar).charCodeAt(); //code of keetru
}

else if (optionString=="nedil-keetru") {
if (myChar!='a') { // 'a' has no visible kuRil
var ev = document.createEvent("KeyEvents");
ev.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 8, 0);
e.target.dispatchEvent(ev); //insert backspace to remove kuRil keetru
}
myCode = getKeetruAnjal(myChar.toUpperCase()).charCodeAt(); //code of nedil keetru
}

else if (optionString=="complex-keetru") {
myCode = getKeetruAnjal(prevChar.concat(myChar)).charCodeAt(); //code of complex keetru
}

else if (optionString=="nedil-letter") {
var ev = document.createEvent("KeyEvents");
ev.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 8, 0);
e.target.dispatchEvent(ev); //insert backspace to remove kuRil letter
myCode = getAnjalChar(myChar.toUpperCase()).charCodeAt(); //code of nedil letter 
}

else if (optionString=="complex-letter") {
var ev = document.createEvent("KeyEvents");
ev.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 8, 0);
e.target.dispatchEvent(ev); //insert backspace to remove prev letter
if (isPrevConsonant) { //insert another backspace (otru + letter)
var ev = document.createEvent("KeyEvents");
ev.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 8, 0);
e.target.dispatchEvent(ev); 
}
myCode = getAnjalChar(prevChar.concat(myChar)).charCodeAt(); //code of complex letter
}

else {
myCode = getAnjalChar(myChar).charCodeAt(); //code of letter
}//all options checked and appropriate charCode assigned 

var evnt = document.createEvent("KeyEvents");
evnt.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 0, myCode);
e.target.dispatchEvent(evnt); // Intended letter inserted

if (myChar=='X') { // the letter 'ksh', which is made of 3 unicode chars
myCode = getAnjalChar(myChar).charCodeAt(1);
var evnt = document.createEvent("KeyEvents");
evnt.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 0, myCode);
e.target.dispatchEvent(evnt);

myCode = getAnjalChar(myChar).charCodeAt(2);
var evnt = document.createEvent("KeyEvents");
evnt.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 0, myCode);
e.target.dispatchEvent(evnt);

}

if (isConsonantAnjal(myChar)) {
var evfnl = document.createEvent("KeyEvents");
myCode = getKeetruAnjal("q").charCodeAt();
evfnl.initKeyEvent("keypress", true, true, document.defaultView, e.ctrlKey, e.altKey, e.shiftKey, e.metaKey, 0, myCode);
e.target.dispatchEvent(evfnl); //insert otru at the end of consonant 
}
}//case: non-text type ends
}//function ends

function handleKeyDownAnjal(e) {
if (e.ctrlKey)
isCtrl = true;
return;
}

function handleKeyUpAnjal(e) {
if (e.ctrlKey)
isCtrl = false;
return;
}

function getAnjalChar(letter) {

var tamilChar = new Array()
// upper row
tamilChar["q"]="ஃ";
tamilChar["w"]="ந்";
tamilChar["e"]="எ";
tamilChar["r"]="ர்";
tamilChar["t"]="ட்";
tamilChar["y"]="ய்";
tamilChar["u"]="உ";
tamilChar["i"]="இ";
tamilChar["o"]="ஒ";
tamilChar["p"]="ப்";

tamilChar["Q"]="ஸ";
tamilChar["E"]="ஏ";
tamilChar["R"]="ற்";
tamilChar["U"]="ஊ";
tamilChar["I"]="ஈ";
tamilChar["O"]="ஓ";

//middle row keys
tamilChar["a"]="அ";
tamilChar["s"]="ச்";
tamilChar["d"]="ட்";
tamilChar["g"]="க்";
tamilChar["h"]="ஹ்";
tamilChar["j"]="ஜ்";
tamilChar["k"]="க்";
tamilChar["l"]="ல்";

tamilChar["A"]="ஆ";
tamilChar["S"]="ஸ்";
tamilChar["H"]="ஹ்";
tamilChar["J"]="ஜ்";
tamilChar["L"]="ள்";


//bottom row keys
tamilChar["z"]="ழ்";
tamilChar["c"]="ச்";
tamilChar["v"]="வ்";
tamilChar["b"]="ப்";
tamilChar["n"]="ன்";
tamilChar["m"]="ம்";

tamilChar["X"]="க்ஷ்";
tamilChar["N"]="ண்";

//Complex characters
tamilChar["n-"]="ந்";
tamilChar["ng"]="ங்";
tamilChar["nj"]="ஞ்";
tamilChar["th"]="த்";
tamilChar["dh"]="த்";
tamilChar["sh"]="ஷ்";
tamilChar["ai"]="ஐ";
tamilChar["au"]="ஔ";


if(tamilChar[letter])
return tamilChar[letter];
else
return letter;
}

function getKeetruAnjal(letter) { 

var keetru = new Array()
keetru["a"]="";
keetru["A"]="\u0bbe";
keetru["i"]="\u0bbf";
keetru["I"]="\u0bc0";
keetru["u"]="\u0bc1";
keetru["U"]="\u0bc2";
keetru["e"]="\u0bc6";
keetru["E"]="\u0bc7";
keetru["ai"]="\u0bc8";
keetru["o"]="\u0bca";
keetru["O"]="\u0bcb";
keetru["au"]="\u0bcc";
keetru["q"]="\u0bcd";
return keetru[letter];
}

function isVowelAnjal(l) {

var vowelArray = new Array('a', 'A', 'i', 'I', 'u', 'U', 'e', 'E', 'o', 'O', 'q');
var i = 0;
while (i<vowelArray.length) {
if (l==vowelArray[i])
return true;
i++;
}
return false;
}

function isConsonantAnjal(l) {

var consonantArray = new Array('k', 'g', 'n', 'c', 's', 't', 'd', 'N', 'h', 'w', '-', 'p', 'b', 'm', 'y', 'r', 'l', 'v', 'z', 'L', 'R', 'S', 'j', 'X');
var i = 0;
while (i<consonantArray.length) {
if (l==consonantArray[i])
return true;
i++;
}
return false;
}

function isComplexChar(l) {

var complexCharArray = new Array('ng', 'nj', 'th', 'dh', 'n-', 'sh', 'ai', 'au');
var i = 0;
while (i<complexCharArray.length) {
if (l==complexCharArray[i])
return true;
i++;
}
return false;
}

function isNedil(l) {
var nedilArray = new Array('A', 'E', 'I', 'O', 'U');
var i = 0;
while (i<nedilArray.length) {
if (l==nedilArray[i])
return true;
i++;
}
return false;
}