﻿var tamilMode = new Boolean();
var isPrevConsonant = new Boolean();
var isCtrl = new Boolean();
var isDispatchedEvent = new Boolean();
var myChar, prevChar, newText;

function tamil99keyboard() {

tamilMode = true;
isPrevConsonant = false;
isCtrl = false;
isDispatchedEvent = false;
window.onkeypress = handleKeyPress;
window.onkeydown = handleKeyDown;
window.onkeyup = handleKeyUp;
return;
}

function handleKeyPress(evt) {

if (evt.charCode && tamilMode && !isCtrl) {
//Case 1: current and prev key pressed are charecters

if (evt.charCode > 255)
return; // dont capture tamil events

myChar = String.fromCharCode(evt.charCode);



if(!isVowel(myChar) && !isConsonant(myChar) && !isSplChar(myChar)){
isPrevConsonant = false;
return; //dont prevent entry of non-Tamil99 characters
}

if ((isVowel(myChar)) && (!isPrevConsonant)) { 
//Case 1.1: prev char is not consonant and current char is a vowel
//Action: enter tamil char of current char in target 
//and set isPrevConsonant to false
evt.preventDefault();
inputTamil(evt, "letter");// Insert Tamil letter
isPrevConsonant = false;
}//case 1.1 ends

else if ((isVowel(myChar)) && (isPrevConsonant)) { 
//Case 1.2: prev char is a consonant and current char is a vowel
//Action: enter 'keetru' of current char in target, and 
//and set isPrevConsonant to false
evt.preventDefault();
inputTamil(evt, "keetru");// Insert keetru
isPrevConsonant = false;
}//case 1.2 ends

else if ((!isVowel(myChar)) && (!isPrevConsonant)) {
//Case 1.3: prev char is not consonant and current char is not vowel
//Action: enter tamil char of current char in target, 
//set isPrevConsonant and set prev char to current char
evt.preventDefault();
inputTamil(evt, "letter");// Insert Tamil letter
isPrevConsonant = isConsonant(myChar);
prevChar = myChar;
}//case 1.3 ends

else if ((!isVowel(myChar)) && (isPrevConsonant)) {
//Case 1.4: prev char is consonant and current char is not a vowel
//Action: check for special condition for auto-dotting (automatic otru insertion)

if (needAutoDot(prevChar, myChar)) { 
//Case 1.4.1: Auto-dot needed
//Action: Enter 'otru' and then tamil letter of evt.charCode, 
//set isPrevConsonant to true and set prev char to current char
evt.preventDefault();
inputTamil(evt, "auto-dot");// Insert dot and then Tamil letter
isPrevConsonant = isConsonant(myChar);
prevChar = myChar;
}//case.1.4.1 ends

else {
//Case 1.4.2: Auto-dot not needed
//Action: enter tamil char of current char in target, 
//set isPrevConsonant and set prev char to current char
evt.preventDefault();
inputTamil(evt, "letter");// Insert Tamil letter
isPrevConsonant = isConsonant(myChar);
prevChar = myChar;
}// case 1.4.2 ends

}// case 1.4 ends

}// case 1 ends

else {
//Case 2: key pressed is non-charecter
if(evt.keyCode==120){//'F9' pressed
tamilMode = !tamilMode;
isPrevConsonant = false;
}
if (evt.keyCode==8) //backspace pressed
isPrevConsonant = false; // reset the conditional flag
}//case 2 ends

}//end of keypress handler function


function inputTamil(e, optionString) {

var myCode;

if (e.target.type=='text') {
if (optionString=="keetru")
e.target.value = e.target.value + getKeetru(myChar);
else if (optionString=="auto-dot")
e.target.value = e.target.value + getKeetru('f') + getTamilChar(myChar);
else
e.target.value = e.target.value + getTamilChar(myChar);
}
else {
//case non-text type
if (optionString=="keetru") {
myCode = getKeetru(myChar).charCodeAt();
}
else if (optionString=="auto-dot") {
var ev = window.document.createEvent("KeyEvents");
myCode = getKeetru('f').charCodeAt();
ev.initKeyEvent("keypress", true, true, window.document.defaultView, false, false, false, false, 0, myCode);
e.target.dispatchEvent(ev); //Otru inserted, before inserting the char
myCode = getTamilChar(myChar).charCodeAt();
}
else {
myCode = getTamilChar(myChar).charCodeAt();
}
var canBubble = new Boolean();
if (isSplChar(myChar))//special char of tamil99
canBubble = false;
else
canBubble = true;
var evnt = window.document.createEvent("KeyEvents");
evnt.initKeyEvent("keypress", canBubble, true, window.document.defaultView, false, false, false, false, 0, myCode);
e.target.dispatchEvent(evnt); // Tamil char/keetru inserted

if (myChar=='T' || myChar=='Y') {
for (i=1; i<4;i++) {
myCode = getTamilChar(myChar).charCodeAt(i);
if (myCode) {
var evnt = window.document.createEvent("KeyEvents");
evnt.initKeyEvent("keypress", true, true, window.document.defaultView, false, false, false, false, 0, myCode);
e.target.dispatchEvent(evnt);
}
}
}
}//case non-text type ends
}//function ends

function handleKeyDown(e) {
if (e.ctrlKey)
isCtrl = true;
return;
}

function handleKeyUp(e) {
if (e.ctrlKey)
isCtrl = false;
return;
}

function getTamilChar(letter) {

var tamilChar = new Array()
// upper row
tamilChar["q"]="ஆ";
tamilChar["w"]="ஈ";
tamilChar["e"]="ஊ";
tamilChar["r"]="ஐ";
tamilChar["t"]="ஏ";
tamilChar["y"]="ள";
tamilChar["u"]="ற";
tamilChar["i"]="ன";
tamilChar["p"]="ண";
tamilChar["o"]="ட";
tamilChar["["]="ச";
tamilChar["]"]="ஞ";

tamilChar["Q"]="ஸ";
tamilChar["W"]="ஷ";
tamilChar["E"]="ஜ";
tamilChar["R"]="ஹ";
tamilChar["T"]="க்ஷ";
tamilChar["Y"]="ஸ்ரீ";
tamilChar["O"]="[";
tamilChar["P"]="]";

//middle row keys
tamilChar["a"]="அ";
tamilChar["s"]="இ";
tamilChar["d"]="உ";
tamilChar["f"]="ஃ";
tamilChar["g"]="எ";
tamilChar["h"]="க";
tamilChar["j"]="ப";
tamilChar["k"]="ம";
tamilChar["l"]="த";
tamilChar[";"]="ந";
tamilChar["\'"]="ய";

tamilChar["F"]="ஃ";
tamilChar["K"]="\"";
tamilChar["L"]=":";
tamilChar[":"]=";";
tamilChar["\""]="\'";

//bottom row keys
tamilChar["z"]="ஔ";
tamilChar["x"]="ஓ";
tamilChar["c"]="ஒ";
tamilChar["v"]="வ";
tamilChar["b"]="ங";
tamilChar["n"]="ல";
tamilChar["m"]="ர";

tamilChar["/"]="ழ";

tamilChar["M"]="/";

if(tamilChar[letter])
return tamilChar[letter];
else
return letter;

}

function getKeetru(letter) { 

var keetru = new Array()
keetru["a"]="";
keetru["q"]="\u0bbe";
keetru["s"]="\u0bbf";
keetru["w"]="\u0bc0";
keetru["d"]="\u0bc1";
keetru["e"]="\u0bc2";
keetru["g"]="\u0bc6";
keetru["t"]="\u0bc7";
keetru["r"]="\u0bc8";
keetru["c"]="\u0bca";
keetru["x"]="\u0bcb";
keetru["z"]="\u0bcc";
keetru["f"]="\u0bcd";
return keetru[letter];
}

function isVowel(l) {

var vowelArray = new Array('a', 'q', 's', 'w', 'd', 'e', 'g', 't', 'r', 'c', 'x', 'z', 'f');
var i = 0;
while (i<vowelArray.length) {
if (l==vowelArray[i])
return true;
i++;
}
return false;
}

function isConsonant(l) {

var consonantArray = new Array('h', 'b', '[', ']', 'o', 'p', 'l', ';', 'j', 'k', '\'', 'm', 'n', 'v', '/', 'y', 'u', 'i', 'Q', 'W', 'E', 'R', 'T', 'Y');
var i = 0;
while (i<consonantArray.length) {
if (l==consonantArray[i])
return true;
i++;
}
return false;
}

function isSplChar(l) {

var splCharArray = new Array('O', 'P', 'K', 'L', ':', '\"', 'M');
var i = 0;
while (i<splCharArray.length) {
if (l==splCharArray[i])
return true;
i++;
}
return false;
}

function needAutoDot(l1,l2) {

if (l1==l2) //same consonants
return true;
if ((l1=='b') && (l2=='h')) //ngka
return true;
if ((l1==']') && (l2=='[')) //njcha
return true;
if ((l1=='p') && (l2=='o')) //Nda
return true;
if ((l1==';') && (l2=='l')) //ntha
return true;
if ((l1=='k') && (l2=='j')) //mba
return true;
if ((l1=='i') && (l2=='u')) //n2Ra
return true;
return false;
}